Index: kernel/arch/sparc64/src/trap/sun4v/trap_table.S
===================================================================
--- kernel/arch/sparc64/src/trap/sun4v/trap_table.S	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/arch/sparc64/src/trap/sun4v/trap_table.S	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -48,6 +48,4 @@
 #include <arch/stack.h>
 #include <arch/sun4v/regdef.h>
-#include <arch/sun4v/arch.h>
-#include <arch/sun4v/cpu.h>
 
 #define TABLE_SIZE	TRAP_TABLE_SIZE
@@ -62,15 +60,9 @@
 
 /* TT = 0x08, TL = 0, instruction_access_exception */
-/* TT = 0x08, TL = 0, IAE_privilege_violation on UltraSPARC T2 */
 .org trap_table + TT_INSTRUCTION_ACCESS_EXCEPTION*ENTRY_SIZE
 .global instruction_access_exception_tl0
 instruction_access_exception_tl0:
-	PREEMPTIBLE_HANDLER instruction_access_exception
-
-/* TT = 0x09, TL = 0, instruction_access_mmu_miss */
-.org trap_table + TT_INSTRUCTION_ACCESS_MMU_MISS*ENTRY_SIZE
-.global instruction_access_mmu_miss_handler_tl0
-	ba fast_instruction_access_mmu_miss_handler_tl0
-	nop
+	/*wrpr %g0, PSTATE_AG_BIT | PSTATE_PRIV_BIT, %pstate
+	PREEMPTIBLE_HANDLER instruction_access_exception*/
 
 /* TT = 0x0a, TL = 0, instruction_access_error */
@@ -80,16 +72,4 @@
 	PREEMPTIBLE_HANDLER instruction_access_error
 
-/* TT = 0x0b, TL = 0, IAE_unauth_access */
-.org trap_table + TT_IAE_UNAUTH_ACCESS*ENTRY_SIZE
-.global iae_unauth_access_tl0
-iae_unauth_access_tl0:
-	PREEMPTIBLE_HANDLER instruction_access_exception
-
-/* TT = 0x0c, TL = 0, IAE_nfo_page */
-.org trap_table + TT_IAE_NFO_PAGE*ENTRY_SIZE
-.global iae_nfo_page_tl0
-iae_nfo_page_tl0:
-	PREEMPTIBLE_HANDLER instruction_access_exception
-
 /* TT = 0x10, TL = 0, illegal_instruction */
 .org trap_table + TT_ILLEGAL_INSTRUCTION*ENTRY_SIZE
@@ -116,28 +96,4 @@
 	PREEMPTIBLE_HANDLER unimplemented_STD
 
-/* TT = 0x14, TL = 0, DAE_invalid_asi */
-.org trap_table + TT_DAE_INVALID_ASI*ENTRY_SIZE
-.global dae_invalid_asi_tl0
-dae_invalid_asi_tl0:
-	PREEMPTIBLE_HANDLER data_access_exception
-
-/* TT = 0x15, TL = 0, DAE_privilege_violation */
-.org trap_table + TT_DAE_PRIVILEGE_VIOLATION*ENTRY_SIZE
-.global dae_privilege_violation_tl0
-dae_privilege_violation_tl0:
-	PREEMPTIBLE_HANDLER data_access_exception
-
-/* TT = 0x16, TL = 0, DAE_nc_page */
-.org trap_table + TT_DAE_NC_PAGE*ENTRY_SIZE
-.global dae_nc_page_tl0
-dae_nc_page_tl0:
-	PREEMPTIBLE_HANDLER data_access_exception
-
-/* TT = 0x17, TL = 0, DAE_nfo_page */
-.org trap_table + TT_DAE_NFO_PAGE*ENTRY_SIZE
-.global dae_nfo_page_tl0
-dae_nfo_page_tl0:
-	PREEMPTIBLE_HANDLER data_access_exception
-
 /* TT = 0x20, TL = 0, fb_disabled handler */
 .org trap_table + TT_FP_DISABLED*ENTRY_SIZE
@@ -177,16 +133,9 @@
 
 /* TT = 0x30, TL = 0, data_access_exception */
-/* TT = 0x30, TL = 0, DAE_side_effect_page for UltraPSARC T2 */
 .org trap_table + TT_DATA_ACCESS_EXCEPTION*ENTRY_SIZE
 .global data_access_exception_tl0
 data_access_exception_tl0:
+	wrpr %g0, PSTATE_AG_BIT | PSTATE_PRIV_BIT, %pstate
 	PREEMPTIBLE_HANDLER data_access_exception
-
-/* TT = 0x31, TL = 0, data_access_mmu_miss */
-.org trap_table + TT_DATA_ACCESS_MMU_MISS*ENTRY_SIZE
-.global data_access_mmu_miss_tl0
-data_access_mmu_miss_tl0:
-	ba fast_data_access_mmu_miss_handler_tl0
-	nop
 
 /* TT = 0x32, TL = 0, data_access_error */
@@ -322,4 +271,10 @@
 	INTERRUPT_LEVEL_N_HANDLER 15
 
+/* TT = 0x60, TL = 0, interrupt_vector_trap handler */
+.org trap_table + TT_INTERRUPT_VECTOR_TRAP*ENTRY_SIZE
+.global interrupt_vector_trap_handler_tl0
+interrupt_vector_trap_handler_tl0:
+	INTERRUPT_VECTOR_TRAP_HANDLER
+
 /* TT = 0x64, TL = 0, fast_instruction_access_MMU_miss */
 .org trap_table + TT_FAST_INSTRUCTION_ACCESS_MMU_MISS*ENTRY_SIZE
@@ -339,10 +294,4 @@
 fast_data_access_protection_handler_tl0:
 	FAST_DATA_ACCESS_PROTECTION_HANDLER 0
-
-/* TT = 0x7c, TL = 0, cpu_mondo */
-.org trap_table + TT_CPU_MONDO*ENTRY_SIZE
-.global cpu_mondo_handler_tl0
-cpu_mondo_handler_tl0:
-PREEMPTIBLE_HANDLER cpu_mondo
 
 /* TT = 0x80, TL = 0, spill_0_normal handler */
@@ -403,17 +352,10 @@
 
 /* TT = 0x08, TL > 0, instruction_access_exception */
-/* TT = 0x08, TL > 0, IAE_privilege_violation on UltraSPARC T2 */
 .org trap_table + (TT_INSTRUCTION_ACCESS_EXCEPTION+512)*ENTRY_SIZE
 .global instruction_access_exception_tl1
 instruction_access_exception_tl1:
 	wrpr %g0, 1, %tl
+	wrpr %g0, PSTATE_AG_BIT | PSTATE_PRIV_BIT, %pstate
 	PREEMPTIBLE_HANDLER instruction_access_exception
-
-/* TT = 0x09, TL > 0, instruction_access_mmu_miss */
-.org trap_table + (TT_INSTRUCTION_ACCESS_MMU_MISS+512)*ENTRY_SIZE
-.global instruction_access_mmu_miss_handler_tl1
-	wrpr %g0, 1, %tl
-	ba fast_instruction_access_mmu_miss_handler_tl0
-	nop
 
 /* TT = 0x0a, TL > 0, instruction_access_error */
@@ -424,18 +366,4 @@
 	PREEMPTIBLE_HANDLER instruction_access_error
 
-/* TT = 0x0b, TL > 0, IAE_unauth_access */
-.org trap_table + (TT_IAE_UNAUTH_ACCESS+512)*ENTRY_SIZE
-.global iae_unauth_access_tl1
-iae_unauth_access_tl1:
-	wrpr %g0, 1, %tl
-	PREEMPTIBLE_HANDLER instruction_access_exception
-
-/* TT = 0x0c, TL > 0, IAE_nfo_page */
-.org trap_table + (TT_IAE_NFO_PAGE+512)*ENTRY_SIZE
-.global iae_nfo_page_tl1
-iae_nfo_page_tl1:
-	wrpr %g0, 1, %tl
-	PREEMPTIBLE_HANDLER instruction_access_exception
-
 /* TT = 0x10, TL > 0, illegal_instruction */
 .org trap_table + (TT_ILLEGAL_INSTRUCTION+512)*ENTRY_SIZE
@@ -445,32 +373,4 @@
 	PREEMPTIBLE_HANDLER illegal_instruction
 
-/* TT = 0x14, TL > 0, DAE_invalid_asi */
-.org trap_table + (TT_DAE_INVALID_ASI+512)*ENTRY_SIZE
-.global dae_invalid_asi_tl1
-dae_invalid_asi_tl1:
-	wrpr %g0, 1, %tl
-	PREEMPTIBLE_HANDLER data_access_exception
-
-/* TT = 0x15, TL > 0, DAE_privilege_violation */
-.org trap_table + (TT_DAE_PRIVILEGE_VIOLATION+512)*ENTRY_SIZE
-.global dae_privilege_violation_tl1
-dae_privilege_violation_tl1:
-	wrpr %g0, 1, %tl
-	PREEMPTIBLE_HANDLER data_access_exception
-
-/* TT = 0x16, TL > 0, DAE_nc_page */
-.org trap_table + (TT_DAE_NC_PAGE+512)*ENTRY_SIZE
-.global dae_nc_page_tl1
-dae_nc_page_tl1:
-	wrpr %g0, 1, %tl
-	PREEMPTIBLE_HANDLER data_access_exception
-
-/* TT = 0x17, TL > 0, DAE_nfo_page */
-.org trap_table + (TT_DAE_NFO_PAGE+512)*ENTRY_SIZE
-.global dae_nfo_page_tl1
-dae_nfo_page_tl1:
-	wrpr %g0, 1, %tl
-	PREEMPTIBLE_HANDLER data_access_exception
-
 /* TT = 0x24, TL > 0, clean_window handler */
 .org trap_table + (TT_CLEAN_WINDOW+512)*ENTRY_SIZE
@@ -490,15 +390,7 @@
 .global data_access_exception_tl1
 data_access_exception_tl1:
-	/*wrpr %g0, 1, %tl
+	wrpr %g0, 1, %tl
 	wrpr %g0, PSTATE_AG_BIT | PSTATE_PRIV_BIT, %pstate
-	PREEMPTIBLE_HANDLER data_access_exception*/
-
-/* TT = 0x31, TL > 0, data_access_mmu_miss */
-.org trap_table + (TT_DATA_ACCESS_MMU_MISS+512)*ENTRY_SIZE
-.global data_access_mmu_miss_tl1
-data_access_mmu_miss_tl1:
-	ba fast_data_access_mmu_miss_handler_tl1
-	nop
-
+	PREEMPTIBLE_HANDLER data_access_exception
 
 /* TT = 0x32, TL > 0, data_access_error */
@@ -527,11 +419,4 @@
 fast_data_access_protection_handler_tl1:
 	FAST_DATA_ACCESS_PROTECTION_HANDLER 1
-
-/* TT = 0x7c, TL > 0, cpu_mondo */
-.org trap_table + (TT_CPU_MONDO+512)*ENTRY_SIZE
-.global cpu_mondo_handler_tl1
-cpu_mondo_handler_tl1:
-	wrpr %g0, %tl
-	PREEMPTIBLE_HANDLER cpu_mondo
 
 /* TT = 0x80, TL > 0, spill_0_normal handler */
@@ -775,4 +660,6 @@
 .endm
 
+
+#if 0
 /*
  * Preemptible trap handler for handling traps from kernel.
@@ -790,4 +677,163 @@
 	nop					! it will be easy to find
 
+	/* prevent unnecessary CLEANWIN exceptions */
+	wrpr %g0, WSTATE_OTHER(0) | WSTATE_NORMAL(0), %wstate
+1:
+	/*
+	 * Prevent SAVE instruction from causing a spill exception. If the
+	 * CANSAVE register is zero, explicitly spill register window
+	 * at CWP + 2.
+	 */
+
+	rdpr %cansave, %g3
+	brnz %g3, 2f
+	nop
+	INLINE_SPILL %g3, %g4
+
+2:
+	/* ask for new register window */
+	save %sp, -PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE, %sp
+
+	/* copy higher level routine's address and its argument */
+	mov %g1, %l0
+	mov %g2, %o0
+
+	/*
+	 * Save TSTATE, TPC and TNPC aside.
+	 */
+	rdpr %tstate, %g1
+	rdpr %tpc, %g2
+	rdpr %tnpc, %g3
+
+	stx %g1, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_TSTATE]
+	stx %g2, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_TPC]
+	stx %g3, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_TNPC]
+
+	/*
+	 * Save the Y register.
+	 * This register is deprecated according to SPARC V9 specification
+	 * and is only present for backward compatibility with previous
+	 * versions of the SPARC architecture.
+	 * Surprisingly, gcc makes use of this register without a notice.
+	 */
+	rd %y, %g4
+	stx %g4, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_Y]
+
+	/* switch to TL = 0, explicitly enable FPU */
+	wrpr %g0, 0, %tl
+	wrpr %g0, 0, %gl
+	wrpr %g0, PSTATE_PRIV_BIT | PSTATE_PEF_BIT, %pstate
+
+	/* g1 -> l1, ..., g7 -> l7 */
+	SAVE_GLOBALS
+
+	/* call higher-level service routine, pass istate as its 2nd parameter */
+	call %l0
+	add %sp, PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_TNPC, %o1
+
+	/* l1 -> g1, ..., l7 -> g7 */
+	RESTORE_GLOBALS
+
+	/* we must prserve the PEF bit */
+	rdpr %pstate, %l1
+
+	/* TL := 1, GL := 1 */
+	wrpr %g0, PSTATE_PRIV_BIT, %pstate
+	wrpr %g0, 1, %tl
+	wrpr %g0, 1, %gl
+
+	/* Read TSTATE, TPC and TNPC from saved copy. */
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_TSTATE], %g1
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_TPC], %g2
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_TNPC], %g3
+
+	/* Copy PSTATE.PEF to the in-register copy of TSTATE. */
+	and %l1, PSTATE_PEF_BIT, %l1
+	sllx %l1, TSTATE_PSTATE_SHIFT, %l1
+	sethi %hi(TSTATE_PEF_BIT), %g4		! reset the PEF bit to 0 ...
+	andn %g1, %g4, %g1
+	or %g1, %l1, %g1			! ... "or" it with saved PEF
+
+	/* Restore TSTATE, TPC and TNPC from saved copies. */
+	wrpr %g1, 0, %tstate
+	wrpr %g2, 0, %tpc
+	wrpr %g3, 0, %tnpc
+
+	/* Restore Y. */
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_Y], %g4
+	wr %g4, %y
+	
+	/* If TSTATE.CWP + 1 == CWP, then we do not have to fix CWP. */
+	and %g1, TSTATE_CWP_MASK, %l0
+	inc %l0
+	and %l0, NWINDOWS - 1, %l0	! %l0 mod NWINDOWS
+	rdpr %cwp, %l1
+	cmp %l0, %l1
+	bz 4f				! CWP is ok
+	nop
+
+3:
+	/*
+	 * Fix CWP.
+	 * In order to recapitulate, the input registers in the current
+	 * window are the output registers of the window to which we want
+	 * to restore. Because the fill trap fills only input and local
+	 * registers of a window, we need to preserve those output
+	 * registers manually.
+	 */
+	mov %sp, %g2
+	stx %i0, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I0]
+	stx %i1, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I1]
+	stx %i2, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I2]
+	stx %i3, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I3]
+	stx %i4, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I4]
+	stx %i5, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I5]
+	stx %i6, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I6]
+	stx %i7, [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I7]
+	wrpr %l0, 0, %cwp
+	mov %g2, %sp
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I0], %i0
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I1], %i1
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I2], %i2
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I3], %i3
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I4], %i4
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I5], %i5
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I6], %i6
+	ldx [%sp + PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE + STACK_BIAS + SAVED_I7], %i7
+
+4:
+	/*
+	 * Prevent RESTORE instruction from causing a fill exception. If the
+	 * CANRESTORE register is zero, explicitly fill register window
+	 * at CWP - 1.
+	 */
+	rdpr %canrestore, %g1
+	brnz %g1, 5f
+	nop
+	INLINE_FILL %g3, %g4
+
+5:
+	restore
+
+	retry
+.endm
+
+#endif
+
+/*
+ * Preemptible trap handler for handling traps from kernel.
+ */
+.macro PREEMPTIBLE_HANDLER_KERNEL
+
+	/*
+	 * ASSERT(%tl == 1)
+	 */
+	rdpr %tl, %g3
+	cmp %g3, 1
+	be 1f
+	nop
+0:	ba 0b					! this is for debugging, if we ever get here
+	nop					! it will be easy to find
+
 1:
 	/* prevent unnecessary CLEANWIN exceptions */
@@ -826,4 +872,6 @@
 	retry
 .endm
+
+
 
 /*
@@ -1044,5 +1092,5 @@
 	and %g1, NWINDOWS - 1, %g1
 	wrpr %g1, 0, %cwp			! CWP--
-	
+
 .if \is_syscall
 	done
@@ -1052,4 +1100,6 @@
 
 .endm
+
+
 
 /* Preemptible trap handler for TL=1.
@@ -1082,2 +1132,3 @@
 trap_instruction_handler:
 	PREEMPTIBLE_HANDLER_TEMPLATE 1
+
Index: kernel/genarch/include/acpi/acpi.h
===================================================================
--- kernel/genarch/include/acpi/acpi.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/genarch/include/acpi/acpi.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -67,5 +67,5 @@
 	uint8_t *signature;
 	struct acpi_sdt_header **sdt_ptr;
-	const char *description;
+	char *description;
 };
 
Index: kernel/genarch/src/acpi/madt.c
===================================================================
--- kernel/genarch/src/acpi/madt.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/genarch/src/acpi/madt.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -72,5 +72,5 @@
 unsigned int madt_entries_index_cnt = 0;
 
-const char *entry[] = {
+char *entry[] = {
 	"L_APIC",
 	"IO_APIC",
Index: kernel/genarch/src/drivers/i8042/i8042.c
===================================================================
--- kernel/genarch/src/drivers/i8042/i8042.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/genarch/src/drivers/i8042/i8042.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -67,6 +67,7 @@
 	i8042_instance_t *instance = irq->instance;
 	i8042_t *dev = instance->i8042;
+	uint8_t status;
 	
-	if (pio_read_8(&dev->status) & i8042_BUFFER_FULL_MASK) {
+	if (((status = pio_read_8(&dev->status)) & i8042_BUFFER_FULL_MASK)) {
 		uint8_t data = pio_read_8(&dev->data);
 		indev_push_character(instance->kbrdin, data);
Index: kernel/generic/include/atomic.h
===================================================================
--- kernel/generic/include/atomic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/atomic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup generic	
  * @{
  */
@@ -36,18 +36,16 @@
 #define KERN_ATOMIC_H_
 
-#include <arch/types.h>
-
 typedef struct atomic {
-	volatile atomic_count_t count;
+	volatile long count;
 } atomic_t;
 
 #include <arch/atomic.h>
 
-static inline void atomic_set(atomic_t *val, atomic_count_t i)
+static inline void atomic_set(atomic_t *val, long i)
 {
 	val->count = i;
 }
 
-static inline atomic_count_t atomic_get(atomic_t *val)
+static inline long atomic_get(atomic_t *val)
 {
 	return val->count;
Index: kernel/generic/include/bitops.h
===================================================================
--- kernel/generic/include/bitops.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/bitops.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -65,6 +65,8 @@
 	}
 	
-	if (arg >> 1)
+	if (arg >> 1) {
+		arg >>= 1;
 		n += 1;
+	}
 	
 	return n;
Index: kernel/generic/include/console/chardev.h
===================================================================
--- kernel/generic/include/console/chardev.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/console/chardev.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -53,5 +53,5 @@
 /** Character input device. */
 typedef struct indev {
-	const char *name;
+	char *name;
 	waitq_t wq;
 	
@@ -81,5 +81,5 @@
 /** Character output device. */
 typedef struct outdev {
-	const char *name;
+	char *name;
 	
 	/** Protects everything below. */
@@ -95,10 +95,10 @@
 } outdev_t;
 
-extern void indev_initialize(const char *name, indev_t *indev,
+extern void indev_initialize(char *name, indev_t *indev,
     indev_operations_t *op);
 extern void indev_push_character(indev_t *indev, wchar_t ch);
 extern wchar_t indev_pop_character(indev_t *indev);
 
-extern void outdev_initialize(const char *name, outdev_t *outdev,
+extern void outdev_initialize(char *name, outdev_t *outdev,
     outdev_operations_t *op);
 
Index: kernel/generic/include/console/kconsole.h
===================================================================
--- kernel/generic/include/console/kconsole.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/console/kconsole.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -94,5 +94,5 @@
 extern void kconsole_notify_init(void);
 extern bool kconsole_check_poll(void);
-extern void kconsole(const char *prompt, const char *msg, bool kcon);
+extern void kconsole(char *prompt, char *msg, bool kcon);
 extern void kconsole_thread(void *data);
 
Index: kernel/generic/include/cpu.h
===================================================================
--- kernel/generic/include/cpu.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/cpu.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -48,5 +48,5 @@
  * There is one structure like this for every processor.
  */
-typedef struct cpu {
+typedef struct {
 	SPINLOCK_DECLARE(lock);
 
Index: kernel/generic/include/errno.h
===================================================================
--- kernel/generic/include/errno.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/errno.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -57,6 +57,11 @@
 #define EADDRNOTAVAIL	-12	/* Address not available. */
 #define ETIMEOUT        -13     /* Timeout expired */
+//MH
+#ifndef EINVAL
 #define EINVAL          -14     /* Invalid value */
+#endif
+#ifndef EBUSY
 #define EBUSY           -15     /* Resource is busy */
+#endif
 #define EOVERFLOW	-16	/* The result does not fit its size. */
 #define EINTR		-17	/* Operation was interrupted. */
Index: kernel/generic/include/interrupt.h
===================================================================
--- kernel/generic/include/interrupt.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/interrupt.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -46,5 +46,5 @@
 typedef void (* iroutine)(int n, istate_t *istate);
 
-extern void fault_if_from_uspace(istate_t *istate, const char *fmt, ...);
+extern void fault_if_from_uspace(istate_t *istate, char *fmt, ...);
 extern iroutine exc_register(int n, const char *name, iroutine f);
 extern void exc_dispatch(int n, istate_t *t);
Index: kernel/generic/include/lib/elf.h
===================================================================
--- kernel/generic/include/lib/elf.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/lib/elf.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -338,5 +338,5 @@
 #endif
 
-extern const char *elf_error(unsigned int rc);
+extern char *elf_error(unsigned int rc);
 
 /* Interpreter string used to recognize the program loader */
Index: kernel/generic/include/mm/slab.h
===================================================================
--- kernel/generic/include/mm/slab.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/mm/slab.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -86,5 +86,5 @@
 
 typedef struct {
-	const char *name;
+	char *name;
 	
 	link_t link;
@@ -123,5 +123,5 @@
 } slab_cache_t;
 
-extern slab_cache_t *slab_cache_create(const char *, size_t, size_t,
+extern slab_cache_t *slab_cache_create(char *, size_t, size_t,
     int (*)(void *, int), int (*)(void *), int);
 extern void slab_cache_destroy(slab_cache_t *);
Index: kernel/generic/include/panic.h
===================================================================
--- kernel/generic/include/panic.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/panic.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -60,5 +60,5 @@
 extern bool silent;
 
-extern void panic_printf(const char *fmt, ...) __attribute__((noreturn));
+extern void panic_printf(char *fmt, ...) __attribute__((noreturn));
 
 #endif
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/proc/task.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -130,5 +130,5 @@
 extern void task_init(void);
 extern void task_done(void);
-extern task_t *task_create(as_t *as, const char *name);
+extern task_t *task_create(as_t *as, char *name);
 extern void task_destroy(task_t *t);
 extern task_t *task_find_by_id(task_id_t id);
Index: kernel/generic/include/proc/thread.h
===================================================================
--- kernel/generic/include/proc/thread.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/proc/thread.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -52,5 +52,5 @@
 #define THREAD_NAME_BUFLEN	20
 
-extern const char *thread_states[];
+extern char *thread_states[];
 
 /* Thread flags */
@@ -225,6 +225,6 @@
 
 extern void thread_init(void);
-extern thread_t *thread_create(void (*)(void *), void *, task_t *, int,
-    const char *, bool);
+extern thread_t *thread_create(void (*)(void *), void *, task_t *, int, char *,
+    bool);
 extern void thread_attach(thread_t *, task_t *);
 extern void thread_ready(thread_t *);
Index: kernel/generic/include/stacktrace.h
===================================================================
--- kernel/generic/include/stacktrace.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/stacktrace.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -46,5 +46,5 @@
 	bool (* frame_pointer_prev)(uintptr_t, uintptr_t *);
 	bool (* return_address_get)(uintptr_t, uintptr_t *);
-	bool (* symbol_resolve)(uintptr_t, const char **, uintptr_t *);
+	bool (* symbol_resolve)(uintptr_t, char **, uintptr_t *);
 } stack_trace_ops_t;
 
Index: kernel/generic/include/symtab.h
===================================================================
--- kernel/generic/include/symtab.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/symtab.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -45,6 +45,6 @@
 };
 
-extern int symtab_name_lookup(uintptr_t, const char **, uintptr_t *);
-extern const char *symtab_fmt_name_lookup(uintptr_t);
+extern int symtab_name_lookup(uintptr_t, char **, uintptr_t *);
+extern char *symtab_fmt_name_lookup(uintptr_t);
 extern int symtab_addr_lookup(const char *, uintptr_t *);
 extern void symtab_print_search(const char *);
Index: kernel/generic/include/synch/spinlock.h
===================================================================
--- kernel/generic/include/synch/spinlock.h	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/include/synch/spinlock.h	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -48,5 +48,5 @@
 	
 #ifdef CONFIG_DEBUG_SPINLOCK
-	const char *name;
+	char *name;
 #endif
 } spinlock_t;
@@ -101,5 +101,5 @@
 	SPINLOCK_STATIC_INITIALIZE_NAME(lock_name, #lock_name)
 
-extern void spinlock_initialize(spinlock_t *lock, const char *name);
+extern void spinlock_initialize(spinlock_t *lock, char *name);
 extern int spinlock_trylock(spinlock_t *lock);
 extern void spinlock_lock_debug(spinlock_t *lock);
Index: kernel/generic/src/console/chardev.c
===================================================================
--- kernel/generic/src/console/chardev.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/console/chardev.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -47,5 +47,5 @@
  *
  */
-void indev_initialize(const char *name, indev_t *indev,
+void indev_initialize(char *name, indev_t *indev,
     indev_operations_t *op)
 {
@@ -130,5 +130,5 @@
  *
  */
-void outdev_initialize(const char *name, outdev_t *outdev,
+void outdev_initialize(char *name, outdev_t *outdev,
     outdev_operations_t *op)
 {
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/console/cmd.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -1033,5 +1033,5 @@
 	/* Execute the test */
 	test_quiet = false;
-	const char *ret = test->entry();
+	char *ret = test->entry();
 	
 	/* Update and read thread accounting */
@@ -1086,5 +1086,5 @@
 		/* Execute the test */
 		test_quiet = true;
-		const char *ret = test->entry();
+		char * ret = test->entry();
 		
 		/* Update and read thread accounting */
Index: kernel/generic/src/console/kconsole.c
===================================================================
--- kernel/generic/src/console/kconsole.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/console/kconsole.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -224,5 +224,5 @@
 		printf("\n");
 		pos = NULL;
-		while (cmdtab_search_one(name, &pos)) {
+		while ((hint = cmdtab_search_one(name, &pos))) {
 			cmd_info_t *hlp = list_get_instance(pos, cmd_info_t, link);
 			printf("%s (%s)\n", hlp->name, hlp->description);
@@ -643,5 +643,5 @@
  *
  */
-void kconsole(const char *prompt, const char *msg, bool kcon)
+void kconsole(char *prompt, char *msg, bool kcon)
 {
 	if (!stdin) {
Index: kernel/generic/src/debug/stacktrace.c
===================================================================
--- kernel/generic/src/debug/stacktrace.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/debug/stacktrace.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -44,7 +44,7 @@
 {
 	int cnt = 0;
-	const char *symbol;
+	char *symbol;
 	uintptr_t offset;
-	
+
 	while (cnt++ < STACK_FRAMES_MAX && ops->frame_pointer_validate(fp)) {
 		if (ops->symbol_resolve &&
@@ -85,5 +85,5 @@
 }
 
-static bool kernel_symbol_resolve(uintptr_t addr, const char **sp, uintptr_t *op)
+static bool kernel_symbol_resolve(uintptr_t addr, char **sp, uintptr_t *op)
 {
 	return (symtab_name_lookup(addr, sp, op) == 0);
Index: kernel/generic/src/debug/symtab.c
===================================================================
--- kernel/generic/src/debug/symtab.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/debug/symtab.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -54,5 +54,5 @@
  *
  */
-int symtab_name_lookup(uintptr_t addr, const char **name, uintptr_t *offset)
+int symtab_name_lookup(uintptr_t addr, char **name, uintptr_t *offset)
 {
 #ifdef CONFIG_SYMTAB
@@ -92,7 +92,7 @@
  *
  */
-const char *symtab_fmt_name_lookup(uintptr_t addr)
-{
-	const char *name;
+char *symtab_fmt_name_lookup(uintptr_t addr)
+{
+	char *name;
 	int rc = symtab_name_lookup(addr, &name, NULL);
 	
@@ -239,5 +239,5 @@
 		printf("\n");
 		pos = 0;
-		while (symtab_search_one(name, &pos)) {
+		while ((hint = symtab_search_one(name, &pos))) {
 			printf("%s\n", symbol_table[pos].symbol_name);
 			pos++;
Index: kernel/generic/src/interrupt/interrupt.c
===================================================================
--- kernel/generic/src/interrupt/interrupt.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/interrupt/interrupt.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -114,5 +114,5 @@
 
 /** Terminate thread and task if exception came from userspace. */
-void fault_if_from_uspace(istate_t *istate, const char *fmt, ...)
+void fault_if_from_uspace(istate_t *istate, char *fmt, ...)
 {
 	task_t *task = TASK;
@@ -162,4 +162,5 @@
 #if (IVT_ITEMS > 0)
 	unsigned int i;
+	char *symbol;
 
 	spinlock_lock(&exctbl_lock);
@@ -176,5 +177,5 @@
 	
 	for (i = 0; i < IVT_ITEMS; i++) {
-		const char *symbol = symtab_fmt_name_lookup((unative_t) exc_table[i].f);
+		symbol = symtab_fmt_name_lookup((unative_t) exc_table[i].f);
 
 #ifdef __32_BITS__
Index: kernel/generic/src/lib/elf.c
===================================================================
--- kernel/generic/src/lib/elf.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/lib/elf.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -48,5 +48,5 @@
 #include <arch.h>
 
-static const char *error_codes[] = {
+static char *error_codes[] = {
 	"no error",
 	"invalid image",
@@ -137,5 +137,5 @@
  * @return NULL terminated description of error.
  */
-const char *elf_error(unsigned int rc)
+char *elf_error(unsigned int rc)
 {
 	ASSERT(rc < sizeof(error_codes) / sizeof(char *));
@@ -155,4 +155,6 @@
     as_t *as, int flags)
 {
+	char *interp;
+
 	switch (entry->p_type) {
 	case PT_NULL:
@@ -163,11 +165,10 @@
 	case PT_DYNAMIC:
 	case PT_INTERP:
-		// FIXME
-		/*
-		char *interp = (char *) elf + entry->p_offset;
-		if (memcmp((uintptr_t) interp, (uintptr_t) ELF_INTERP_ZSTR,
+		interp = (char *)elf + entry->p_offset;
+		/* FIXME */
+		/*if (memcmp((uintptr_t)interp, (uintptr_t)ELF_INTERP_ZSTR,
 		    ELF_INTERP_ZLEN) != 0) {
 			return EE_UNSUPPORTED;
-		} */
+		}*/
 		if ((flags & ELD_F_LOADER) == 0) {
 			return EE_LOADER;
Index: kernel/generic/src/main/kinit.c
===================================================================
--- kernel/generic/src/main/kinit.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/main/kinit.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -183,6 +183,7 @@
 		
 		char namebuf[TASK_NAME_BUFLEN];
-		
-		const char *name = init.tasks[i].name;
+		char *name;
+		
+		name = init.tasks[i].name;
 		if (name[0] == 0)
 			name = "<unknown>";
Index: kernel/generic/src/main/version.c
===================================================================
--- kernel/generic/src/main/version.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/main/version.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -37,20 +37,20 @@
 #include <macros.h>
 
-static const char *project = "SPARTAN kernel";
-static const char *copyright = "Copyright (c) 2001-2010 HelenOS project";
-static const char *release = STRING(RELEASE);
-static const char *name = STRING(NAME);
-static const char *arch = STRING(KARCH);
+char *project = "SPARTAN kernel";
+char *copyright = "Copyright (c) 2001-2009 HelenOS project";
+char *release = STRING(RELEASE);
+char *name = STRING(NAME);
+char *arch = STRING(KARCH);
 
 #ifdef REVISION
-	static const char *revision = ", revision " STRING(REVISION);
+	char *revision = ", revision " STRING(REVISION);
 #else
-	static const char *revision = "";
+	char *revision = "";
 #endif
 
 #ifdef TIMESTAMP
-	static const char *timestamp = " on " STRING(TIMESTAMP);
+	char *timestamp = " on " STRING(TIMESTAMP);
 #else
-	static const char *timestamp = "";
+	char *timestamp = "";
 #endif
 
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision aa85487c600b0fee35e8be1a6edd9b5b1a9a0646)
+++ kernel/generic/src/mm/as.c	(revision 2e992773e5f019775f8da23f506b24fe7ec905b0)
@@ -784,4 +784,5 @@
 {
 	as_area_t *area;
+	uintptr_t base;
 	link_t *cur;
 	ipl_t ipl;
@@ -812,4 +813,6 @@
 		return ENOTSUP;
 	}
+
+	base = area->base;
 
 	/*
@@ -949,10 +952,9 @@
 	if (!THREAD)
 		return AS_PF_FAULT;
-	
-	if (!AS)
-		return AS_PF_FAULT;
-	
+		
+	ASSERT(AS);
+
 	mutex_lock(&AS->lock);
-	area = find_area_and_lock(AS, page);
+	area = find_area_and_lock(AS, page);	
 	if (!area) {
 		/*
